Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.io.comparator
Class PathFileComparator

    java.lang.Object
      org.apache.commons.io.comparator.PathFileComparator

All Implemented Interfaces:
  Serializable, Comparator<File>

    public class PathFileComparator

extends Object
implements Serializable

Compare the path of two files for order (see `File.getPath()`).

This comparator can be used to sort lists or arrays of files by their path either in a case-sensitive, case-insensitive or system dependant case sensitive way. A number of singleton instances are provided for the various case sensitivity options (using `IOCase`) and the reverse of those options.

Example of a case-sensitive file path sort using the `PATH_COMPARATOR` singleton instance:

           List<File> list = ...
           PathFileComparator.PATH_COMPARATOR.sort(list);

Example of a reverse case-insensitive file path sort using the `PATH_INSENSITIVE_REVERSE` singleton instance:

           File[] array = ...
           PathFileComparator.PATH_INSENSITIVE_REVERSE.sort(array);

Since:
  Commons IO 1.4
Version:
  $Revision: 723942 $ $Date: 2008-12-05 20:24:06 -0500 (Fri, 05 Dec 2008) $
See Also:
  Serialized Form

Field Summary
`static Comparator<File>` | `PATH_COMPARATOR` Case-sensitive path comparator instance (see `IOCase.SENSITIVE`)
`static Comparator<File>` | `PATH_INSENSITIVE_COMPARATOR` Case-insensitive path comparator instance (see `IOCase.INSENSITIVE`)
`static Comparator<File>` | `PATH_INSENSITIVE_REVERSE` Reverse case-insensitive path comparator instance (see `IOCase.INSENSITIVE`)
`static Comparator<File>` | `PATH_REVERSE` Reverse case-sensitive path comparator instance (see `IOCase.SENSITIVE`)
`static Comparator<File>` | `PATH_SYSTEM_COMPARATOR` System sensitive path comparator instance (see `IOCase.SYSTEM`)
`static Comparator<File>` | `PATH_SYSTEM_REVERSE` Reverse system sensitive path comparator instance (see `IOCase.SYSTEM`)

Constructor Summary
`PathFileComparator()` Construct a case sensitive file path comparator instance.
`PathFileComparator(IOCase caseSensitivity)` Construct a file path comparator instance with the specified case-sensitivity.

Method Summary
`int` | `compare(File file1, File file2)` Compare the paths of two files the specified case sensitivity.
`File[]` | `sort(File... files)` Sort an array of files.
`List<File>` | `sort(List<File> files)` Sort a List of files.
`String` | `toString()` String representation of this file comparator.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Comparator
`equals`

Field Detail

### PATH_COMPARATOR

    public static final Comparator<File> PATH_COMPARATOR

  Case-sensitive path comparator instance (see `IOCase.SENSITIVE`)

### PATH_REVERSE

    public static final Comparator<File> PATH_REVERSE

  Reverse case-sensitive path comparator instance (see `IOCase.SENSITIVE`)

### PATH_INSENSITIVE_COMPARATOR

    public static final Comparator<File> PATH_INSENSITIVE_COMPARATOR

  Case-insensitive path comparator instance (see `IOCase.INSENSITIVE`)

### PATH_INSENSITIVE_REVERSE

    public static final Comparator<File> PATH_INSENSITIVE_REVERSE

  Reverse case-insensitive path comparator instance (see `IOCase.INSENSITIVE`)

### PATH_SYSTEM_COMPARATOR

    public static final Comparator<File> PATH_SYSTEM_COMPARATOR

  System sensitive path comparator instance (see `IOCase.SYSTEM`)

### PATH_SYSTEM_REVERSE

    public static final Comparator<File> PATH_SYSTEM_REVERSE

  Reverse system sensitive path comparator instance (see `IOCase.SYSTEM`)

Constructor Detail

### PathFileComparator

    public PathFileComparator()

  Construct a case sensitive file path comparator instance.

### PathFileComparator

    public PathFileComparator(IOCase caseSensitivity)

  Construct a file path comparator instance with the specified case-sensitivity.

  Parameters:
    `caseSensitivity` - how to handle case sensitivity, null means case-sensitive

Method Detail

### compare

    public int compare(File file1,
                       File file2)

  Compare the paths of two files the specified case sensitivity.

  Specified by:
    `compare` in interface `Comparator<File>`
  Parameters:
    `file1` - The first file to compare
    `file2` - The second file to compare
  Returns:
    a negative value if the first file's path is less than the second, zero if the paths are the same and a positive value if the first files path is greater than the second file.

### toString

    public String toString()

  String representation of this file comparator.

  Returns:
    String representation of this file comparator

### sort

    public File[] sort(File... files)

  Sort an array of files.

  This method uses `Arrays.sort(Object[], Comparator)` and returns the original array.

  Parameters:
    `files` - The files to sort, may be null
  Returns:
    The sorted array
  Since:
    Commons IO 2.0

### sort

    public List<File> sort(List<File> files)

  Sort a List of files.

  This method uses `Collections.sort(List, Comparator)` and returns the original list.

  Parameters:
    `files` - The files to sort, may be null
  Returns:
    The sorted list
  Since:
    Commons IO 2.0

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2011 The Apache Software Foundation. All Rights Reserved.